/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.example.android.Btv_TOV;

import java.text.NumberFormat;

import com.example.android.Btv_TOV.R;

import android.app.Activity;
//import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.Vibrator;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.Button;
//import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ProgressBar;

/**
 * This is the main Activity that displays the current chat session.
 */
public class Btv_TOV extends Activity implements OnClickListener{
    // Debugging
    private static final String TAG = "Btv_TOV";
    private static final boolean D = true;

    // Message types sent from the BluetoothChatService Handler
    public static final int MESSAGE_STATE_CHANGE = 1;
    public static final int MESSAGE_READ = 2;
    public static final int MESSAGE_WRITE = 3;
    public static final int MESSAGE_DEVICE_NAME = 4;
    public static final int MESSAGE_TOAST = 5;

    // Key names received from the BluetoothChatService Handler
    public static final String DEVICE_NAME = "device_name";
    public static final String TOAST = "toast";

    // Intent request codes
    private static final int REQUEST_CONNECT_DEVICE_SECURE = 1;
//    private static final int REQUEST_CONNECT_DEVICE_INSECURE = 2;
    private static final int REQUEST_ENABLE_BT = 3;
    private static final int  REQUEST_CONNECT_DEFAULT_DEVICE = 4;

    // Layout Views
    private TextView mTitle;
    private ListView mConversationView;
//    private EditText mOutEditText;
//    private Button mSendButton;

    // Name of the connected device
    private String mConnectedDeviceName = null;
    // Array adapter for the conversation thread
    private ArrayAdapter<String> mConversationArrayAdapter;
    // String buffer for outgoing messages
//    private StringBuffer mOutStringBuffer;
    // Local Bluetooth adapter
    private BluetoothAdapter mBluetoothAdapter = null;
    // Member object for the chat services
    private TovBluetoothService mChatService = null;

     //DSR
    private Button StartButton;
    private Button StopButton;
    
    private String sprungliste[]; 
    private double punkteliste[]; 
    private int letzterSprung=99;
    private int started=0;
    private int aufgezeichnet=0;
	private int sn=0;
	private double punkte=0;
	private  ProgressBar mProgressUbatt;
	private  TextView mTextViewUbatt;
	private  TextView mTextViewN;
	private  TextView mTextViewLetzte4Spruenge;
	private  ListView mListView;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if(D) Log.e(TAG, "+++ ON CREATE +++");

        // Set up the window layout
        requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
//        setContentView(R.layout.main);
        setContentView(R.layout.aufnahme);
        getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.custom_title);

        // Set up the custom title
        mTitle = (TextView) findViewById(R.id.title_left_text);
        mTitle.setText(R.string.app_name);
        mTitle = (TextView) findViewById(R.id.title_right_text);

        // Get local Bluetooth adapter
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

        // If the adapter is null, then Bluetooth is not supported
        if (mBluetoothAdapter == null) {
            Toast.makeText(this, "Bluetooth is not available", Toast.LENGTH_LONG).show();
            finish();
            return;
        }
        StartButton = (Button)findViewById(R.id.start_button);
        StartButton.setOnClickListener(this);
        StopButton = (Button)findViewById(R.id.stop_button);
        StopButton.setOnClickListener(this);

        sprungliste= new String[10];
        punkteliste= new double[10];
        for (int i=0; i<10; i++){
        	sprungliste[i]="-";
        	punkteliste[i]=0;
        }
        mProgressUbatt = (ProgressBar) findViewById(R.id.progressBarUbatt);
        mTextViewUbatt = (TextView) findViewById(R.id.TextViewUbatt);
        mTextViewN = (TextView) findViewById(R.id.TextViewN);
        mTextViewLetzte4Spruenge = (TextView) findViewById(R.id.TextViewLetzteSpruenge);
        mListView = (ListView) findViewById(R.id.liste);
    }
    
    
    public void onClick(View v) {
 
/*        String name = nameField.getText().toString();
 
        if (name.length() == 0) {
            new AlertDialog.Builder(this).setMessage(
                    R.string.error_name_missing).setNeutralButton(
                    R.string.error_ok,
                    null).show();
            return;
        }
*/
        if (v == StartButton){
        	started=1;
    		mListView.setBackgroundColor(Color.rgb(0x80,0,0)); // red
        	aufgezeichnet=0;
        	punkte=0;
        	letzterSprung = sn;
            for (int i=0; i<10; i++){
            	sprungliste[i]="-";
            	punkteliste[i]=0;
            }
            // Get instance of Vibrator from current Context
            Vibrator brr = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);

            // Vibrate for 450 milliseconds
            brr.vibrate(150);
            
        }
        if (v == StopButton){
        	started=0;
    		mListView.setBackgroundColor(Color.BLACK); 
            // Get instance of Vibrator from current Context
            Vibrator brr = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);

            // Vibrate for 75 milliseconds
            brr.vibrate(75);
        }

/*        	
        	if (v == StartButton || v == StopButton) {
            int resourceId = v == StartButton ? R.string.start_message
                    : R.string.stop_message;

//            String greeting = getResources().getString(resourceId, name);
            String greeting = getResources().getString(resourceId);
            Toast.makeText(this, greeting, Toast.LENGTH_LONG).show();

//            TextView greetingField = (TextView) findViewById(R.id.greeting_field);
//            greetingField.setText(greeting);
        }
*/        
    }    

    @Override
    public void onStart() {
        super.onStart();
        if(D) Log.e(TAG, "++ ON START ++");

        // If BT is not on, request that it be enabled.
        // setupChat() will then be called during onActivityResult
        if (!mBluetoothAdapter.isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
        // Otherwise, setup the chat session
        } else {
            if (mChatService == null) setupChat();
        }
    }

    @Override
    public synchronized void onResume() {
        super.onResume();
        if(D) Log.e(TAG, "+ ON RESUME +");

        // Performing this check in onResume() covers the case in which BT was
        // not enabled during onStart(), so we were paused to enable it...
        // onResume() will be called when ACTION_REQUEST_ENABLE activity returns.
        if (mChatService != null) {
            // Only if the state is STATE_NONE, do we know that we haven't started already
            if (mChatService.getState() == TovBluetoothService.STATE_NONE) {
              // Start the Bluetooth chat services
              mChatService.start();
            }
        }
    }

    private void setupChat() {

        Log.d(TAG, "setupChat()");

//        Intent  serverIntent = new Intent(this, DeviceListActivity.class);
//        startActivityForResult(serverIntent, REQUEST_CONNECT_DEFAULT_DEVICE);

        // Initialize the array adapter for the conversation thread
//        mConversationArrayAdapter = new ArrayAdapter<String>(this, R.layout.message);
        mConversationArrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
//        mConversationArrayAdapter = new ArrayAdapter<String>(this, android.R.layout.mylist);
        mConversationView = (ListView) findViewById(R.id.liste);
        mConversationView.setAdapter(mConversationArrayAdapter);

        // Initialize the BluetoothChatService to perform bluetooth connections
        mChatService = new TovBluetoothService(this, mHandler);
        connectDefaultDevice();

    }

    @Override
    public synchronized void onPause() {
        if(D) Log.e(TAG, "- ON PAUSE -");
    }

    @Override
    public void onStop() {
        super.onStop();
        if(D) Log.e(TAG, "-- ON STOP --");
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        // Stop the Bluetooth chat services
        if (mChatService != null) mChatService.stop();
        if(D) Log.e(TAG, "--- ON DESTROY ---");
    }

    // The Handler that gets information back from the BluetoothChatService
    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
            case MESSAGE_STATE_CHANGE:
                if(D) Log.i(TAG, "MESSAGE_STATE_CHANGE: " + msg.arg1);
                switch (msg.arg1) {
                case TovBluetoothService.STATE_CONNECTED:
                    mTitle.setText(R.string.title_connected);
//                    mTitle.append(" "+mConnectedDeviceName);
                    mConversationArrayAdapter.clear();
                    break;
                case TovBluetoothService.STATE_CONNECTING:
                    mTitle.setText(R.string.title_connecting);
                    break;
                case TovBluetoothService.STATE_LISTEN:
                case TovBluetoothService.STATE_NONE:
                    mTitle.setText(R.string.title_not_connected);
                    break;
                }
                break;
            case MESSAGE_READ:
            	String life="?";
            	String line = (String) msg.obj;
            	byte data[] = line.getBytes(); 
            	
            	int z;
            	float t1,t2,t3,t4,ubatt;
            	
            	sn = data[1] & 15;
            	z = (data[1]/16) & 3;

            	t1=(data[2]-32) * 64  + data[3]-32;
            	t2=(data[4]-32) * 64  + data[5]-32;
            	t3=(data[6]-32) * 64  + data[7]-32;
            	t4=(data[8]-32) * 64  + data[9]-32;
            	ubatt=data[10];

            	t1/=1000;
            	t2/=1000;
            	t3/=1000;
            	t4/=1000;
            	ubatt/=10;
            	/*            
	               Data[]  Inhalt            Wertebereich
	                0    Start-Kennung     10
	                1    Life Indikator      64+ (32+16)   Bit 4,5
	                1    Seqenznummer        64+ (8+4+2+1) Bits 0..3    
	                2    T1 MSB               32+T1/64  Flugzeit in Millisekunden
	                3    T1 LSB               32+T1%64 
	                4    T2 MSB               32+T2/64 
	                5    T2 LSB               32+T2%64 
	                6    T3 MSB               32+T3/64 
	                7    T3 LSB               32+T3%64 
	                8    T4 MSB               32+T4/64 
	                9    T4 LSB               32+T4%64 
	                10   Ubatt                50-70
            	 */
            	mTextViewN.setText(Integer.toString(sn));

            	double un=ubatt - 5.0;
            	if (un<0) un=0;
            	un*=60;
            	if (un>100) un=100;
            	mProgressUbatt.setProgress((int)un);

            	switch(z){
            	case 0: life="\\"; break;
            	case 1: life="|";  break;
            	case 2: life="/";  break;
            	case 3: life="-";  break;
            	}

            	NumberFormat nf = NumberFormat.getNumberInstance();
            	nf.setMinimumFractionDigits(1);
            	nf.setMaximumFractionDigits(1);
            	mTextViewUbatt.setText(nf.format(ubatt)+"V      "+life );

            	nf.setMinimumFractionDigits(3);
            	nf.setMaximumFractionDigits(3);
            	mTextViewLetzte4Spruenge.setText(nf.format(t1)+"s     " +nf.format(t2)+"s    "+nf.format(t3)+"s     "+nf.format(t4)+"s ...");

            	if (started >0){
            		mListView.setBackgroundColor(Color.rgb(0x80,0,0)); // red
            		nf.setMinimumFractionDigits(3);
            		nf.setMaximumFractionDigits(3);
            		while (sn != letzterSprung){
            			punkte+=  Math.round(t1*200)/200.0;
                        //punkte+=t1;
            			sprungliste[aufgezeichnet]=nf.format(t1);
            			punkteliste[aufgezeichnet]=punkte;
            			t1=t2;
            			t2=t3;
            			t3=t4;
            			letzterSprung++;
            			if (letzterSprung>15) letzterSprung=0;
            			aufgezeichnet++;
            			if (aufgezeichnet>9){
            				started=0;
                    		mListView.setBackgroundColor(Color.BLACK);
            			}
            		}
            	}else{
            		mListView.setBackgroundColor(Color.BLACK);
            	}

            	mConversationArrayAdapter.clear();
            	nf.setMinimumFractionDigits(3);
            	nf.setMaximumFractionDigits(3);

            	for (int i=0; i<10; i++){
            		Integer n=i+1;
            		if (punkteliste[i]>0.0){
            			/* Kein runden auf 1/20stel    						
    						int f20 = (int)(punkteliste[i]*20);
    						double rund=f20;
    						rund/=20;
            			 */    						
            			mConversationArrayAdapter.add(n.toString()+": "+sprungliste[i]+"s \t\t\t\t"+nf.format(punkteliste[i])+" Punkte");
            		}else{
            			if (sprungliste[i]!="-"){
            				mConversationArrayAdapter.add(n.toString()+": "+sprungliste[i]+"s");
            			}else{
            				mConversationArrayAdapter.add(n.toString()+":");
            			}
            		}
            	}
                break;
                
            case MESSAGE_DEVICE_NAME:
                // save the connected device's name
                mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
                Toast.makeText(getApplicationContext(), "Connected to "
                               + mConnectedDeviceName, Toast.LENGTH_SHORT).show();
                break;
            case MESSAGE_TOAST:
                Toast.makeText(getApplicationContext(), msg.getData().getString(TOAST),
                               Toast.LENGTH_SHORT).show();
                break;
            }
        }
    };

    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if(D) Log.d(TAG, "onActivityResult " + resultCode);
        switch (requestCode) {
        case REQUEST_CONNECT_DEFAULT_DEVICE:
            connectDefaultDevice();
            break;
        case REQUEST_CONNECT_DEVICE_SECURE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                connectDevice(data);
            }
            break;
        case REQUEST_ENABLE_BT:
            // When the request to enable Bluetooth returns
            if (resultCode == Activity.RESULT_OK) {
                // Bluetooth is now enabled, so set up a chat session
                setupChat();
            } else {
                // User did not enable Bluetooth or an error occured
                Log.d(TAG, "BT not enabled");
                Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                finish(); //App beenden
            }
        }
    }

    private void connectDevice(Intent data) {
        // Get the device MAC address
        String address = data.getExtras()
            .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
        // Get the BLuetoothDevice object
        BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
        // Attempt to connect to the device
        mChatService.connect(device);
    }
    private void connectDefaultDevice() {
        // Use the device MAC address of the adapter from "SURE" 
        String address = "00:1D:43:00:C3:54";
        // Get the BLuetoothDevice object
        BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
        // Attempt to connect to the device
        mChatService.connect(device);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.option_menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Intent serverIntent = null;
        switch (item.getItemId()) {
        case R.id.secure_connect_scan:
            // Launch the DeviceListActivity to see devices and do scan
            serverIntent = new Intent(this, DeviceListActivity.class);
            startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE_SECURE);
            return true;
        case R.id.close_connection:
            // Stop the Bluetooth services
            if (mChatService != null) mChatService.stop();
        	return true;
        case R.id.close_app:
        	// close connection and finish app
            if (mChatService != null) mChatService.stop();
            System.exit(0);
        	return true;
        }
        return false;
    }

}
